> For the complete documentation index, see [llms.txt](https://developers.felt.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.felt.com/js-sdk-api-reference/tools.md).

# Tools

***

The Tools part of the Felt SDK allows you to let users draw elements on the map by programmatically selecting a tool for them.

You can also set the settings for individual tools, to allow you to change the styling of the resulting element.

## Example

```ts
// Change the settings for the line tool
felt.setToolSettings({
  tool: "line",
  strokeWidth: 8,
  color: "#448C2A"
});

// Start using the line tool
felt.setTool("line");

// Put down the tool
felt.setTool(null);
```

> To create elements programmatically, use the [ElementsController](/js-sdk-api-reference/elements/elementscontroller.md) instead.

## Controller

* [ToolsController](/js-sdk-api-reference/tools/toolscontroller.md)

## Interfaces

* [PinToolSettings](/js-sdk-api-reference/tools/pintoolsettings.md)
* [LineToolSettings](/js-sdk-api-reference/tools/linetoolsettings.md)
* [RouteToolSettings](/js-sdk-api-reference/tools/routetoolsettings.md)
* [PolygonToolSettings](/js-sdk-api-reference/tools/polygontoolsettings.md)
* [IsochroneToolSettings](/js-sdk-api-reference/tools/isochronetoolsettings.md)
* [CircleToolSettings](/js-sdk-api-reference/tools/circletoolsettings.md)
* [MarkerToolSettings](/js-sdk-api-reference/tools/markertoolsettings.md)
* [HighlighterToolSettings](/js-sdk-api-reference/tools/highlightertoolsettings.md)
* [TextToolSettings](/js-sdk-api-reference/tools/texttoolsettings.md)
* [NoteToolSettings](/js-sdk-api-reference/tools/notetoolsettings.md)

## Type Aliases

* [ToolType](/js-sdk-api-reference/tools/tooltype.md)
* [ConfigurableToolType](/js-sdk-api-reference/tools/configurabletooltype.md)
* [InputToolSettings](/js-sdk-api-reference/tools/inputtoolsettings.md)
* [ToolSettingsChangeEvent](/js-sdk-api-reference/tools/toolsettingschangeevent.md)
* [ToolSettingsMap](/js-sdk-api-reference/tools/toolsettingsmap.md)
* [PlaceFrame](/js-sdk-api-reference/tools/placeframe.md)
* [PlaceSymbol](/js-sdk-api-reference/tools/placesymbol.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://developers.felt.com/js-sdk-api-reference/tools.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
